// Dragon Code Decoder
// Version: dcd-2.5a
// COPYRIGHT 2000 Amthrax Arlan

#include <stdio.h>
#include <string.h>
#include <wctype.h>

void DCDecode(char in[], char *out, int forcever=0);

void main(void)
{
	char in[512],out[8192],line[100];
	unsigned int outpos,linepos,wordbeginout,wordbeginline,tabpos;
	unsigned int tabposes[9]={10,18,26,34,42,50,58,66,74};
	int i,curline;

	printf("\n");
	printf("Dragon Code Decoder dcd-2.5a\t\t\t\t    Written by Amthrax\r\n");
	printf("  The Dragon Code page is maintained by Wyrm at: http://www.dragoncode.org/\n");
	printf("        Text descriptions and comments based on those at Wyrm's site\n");
	printf("          Send any bugs/comments/suggestions to aclements@sisna.com\n");
	printf("\n");
	printf("Enter Dragon Code: ");
	gets(in);
	strcpy(out,"\n");
	DCDecode(in,out);
	// Format the output, ugh (doesn't work very cleanly, but appears to at least work)
	outpos=0;
	tabpos=0;
	curline=0;
	while(outpos<strlen(out))
	{
		linepos=0;
		for (linepos=0;linepos<tabpos;linepos++)
			line[linepos]=' ';
		while(linepos<79&&outpos<strlen(out))
		{
			// Get the next word
			wordbeginout=outpos;
			wordbeginline=linepos;
			while(!iswspace(out[outpos])&&linepos<=79&&outpos<strlen(out))
			{
				line[linepos++]=out[outpos++];
				if (linepos>79)	// Word went over
				{
					line[wordbeginline]=0;
					outpos=wordbeginout-1;
				}
			}
			if (out[outpos]=='\n')
			{
				tabpos=0;
				line[linepos]=0;
				linepos=79;
			} else if (out[outpos]=='\t') {
				tabpos=10;
				for(i=0;i<9;i++)
					if (tabposes[i]>linepos+1)
					{
						tabpos=tabposes[i];
						break;
					}
				for(;linepos<tabpos;linepos++)
					line[linepos]=' ';
				linepos--;
			} else
				line[linepos]=out[outpos];
			linepos++;
			outpos++;
			line[linepos]=0;
		}
		linepos=strlen(line);
		if (linepos<79)
		{
			for (;linepos<79;linepos++)
				line[linepos]=' ';
			line[linepos]=0;
		}
		line[79]=0;		// Just in case
		printf("%s\n",line);
		while(outpos<strlen(out)&&iswspace(out[outpos])&&out[outpos]!='\n') outpos++;
		if (out[outpos]=='\n')
		{
			outpos++;		// No blank newlines
			tabpos=0;
		}
	}
//	printf("\n%s",out);
}
